#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "headers.h"
#ifdef SGI
#include <GL/glut.h>
#else
#include <GL\glut.h>
#endif

extern int wholeGame[MAX_GAME_LENGTH+1][NUM_SQUARES+1]; /* all the moves so far */
extern int turn; /*** RED or WHITE ***/
extern int redLevel,whiteLevel; /*** The max time for the computer to think ***/
extern int red_strategy,white_strategy; /*** Which heuristic to use ***/
static int level; /*** The max depth to search(This is used in itterative deepening) ***/
static int start_time; /* the starting time of a move */
static int glob_counter=0; /* incremented every time MIN-VALUE or MAX-VALUE is called */

int anti_jef(int board[BOARDSIZE+1],int color, int depth)
{
	int i;
	int legMoves[MAX_MOVES];
	int num_friend_men=0,num_enemy_men=0;
	int num_friend_kings=0, num_enemy_kings=0,sum=0;
	int repeat_depth=0;
	for(i=1;i<=NUM_SQUARES;i++)
	{
		if(board[i]==color)
			num_friend_men++;
		else if(board[i]==color+2)
			num_friend_kings++;
		else if (board[i]==(color^1))
			num_enemy_men++;
		else if(board[i]==((color^1)+2))
			num_enemy_kings++;
	}
	sum=(num_friend_men+num_friend_kings-num_enemy_men-num_enemy_kings)*1200000;
	if(sum>0) /*some inscentive to trade when you are winning */
	{
		sum=sum+100000*(12-(num_enemy_men+num_enemy_kings));
		if(num_friend_kings > 0)
			sum=sum-farness_of_kings(board,turn);
		repeat_depth=isRepeat(2);
		if(repeat_depth)
			sum=sum-50000;
		/*sum=sum+15000*num_peices_trapped(board,turn^1);*/
		sum=sum-num_safe_moves(board,turn^1);
		/*sum=sum+60*num_safe_moves(board,turn);*/
	}
	else if(sum==0)
	{ 
		if(num_friend_kings > 0)
			sum=sum-farness_of_kings(board,turn);
		/*	sum=sum+15000*num_peices_trapped(board,turn^1);
		sum=sum-15000*num_peices_trapped(board,turn); */
		sum=sum-num_safe_moves(board,turn^1);
		sum=sum+num_safe_moves(board,turn); 
	}
	else if (sum<0) /*some inscentive not to trade when you are losing */
	{
		sum=sum-100000*(12-(num_friend_men+num_friend_kings));
		if(num_enemy_kings>0)
			sum=sum+farness_of_kings(board,turn^1);
		repeat_depth=isRepeat(2);
		if(repeat_depth)
			sum=sum+50000; 
		/*sum=sum-15000*num_peices_trapped(board,turn);*/
		/*	sum=sum-60*num_safe_moves(board,turn^1);*/
		sum=sum+num_safe_moves(board,turn);
	}
	
	if(num_enemy_men>0)
		sum=sum+10*num_in_last_rank(board,turn);
	if(num_friend_men>0)
		sum=sum-10*num_in_last_rank(board,turn^1);
	sum=sum-farness_of_pawns(turn,board);
	sum=sum+farness_of_pawns(turn^1,board); /* the farther the better */
	sum=sum+700000*(num_friend_kings-num_enemy_kings); /* some inscentive to get kings and jump kings */
	findLegalMoves(color^1, board, legMoves);
	if(legMoves[0]==0)
	{
		if(color==turn)
			sum=WIN-depth;
		else
			sum=LOSS+depth;
	}
	if (num_friend_men+num_friend_kings==0) /*if it is a losing position*/
		sum=LOSS+depth; /*worse at lower depth*/ 
	if(num_enemy_men+num_enemy_kings==0) /*if it is a winning position*/
		sum=WIN-depth; /*better at lower depth*/
	return(sum);
}/* end anti_jef() */

void bestMove(int board[BOARDSIZE],int color, int* from, int* to, int jump_at1)
{	
	int num_moves,allBoards[MAX_MOVES][NUM_SQUARES+1];
	int i,j,jump_at2=0;
	int alpha=LOSS, beta=WIN, best_value=LOSS;
	int legMoves[MAX_MOVES],jumps[5];
	int new_value=0;
	int saved_level;
	int moves_so_far;
	int spots[MAX_MOVES]; /* The idea is to start the next itterative deepening
	on the same move*/
	int ivalue;
	if(turn==RED)
		saved_level=redLevel;
	else
		saved_level=whiteLevel;
	
	glob_counter=0;
	start_time=clock();
	if(jump_at1==0)
	{
		num_moves=findLegalBoards(color,board,allBoards);
		findLegalMoves(color,board,legMoves);
	}
	else
	{
		num_moves=findLegalBoardsFromSquare(board,allBoards,jump_at1);
		findLegalJumpsFromSquare(board,jumps,jump_at1);
		legMoves[0]=jumps[0];
		legMoves[1]=jumps[0];
		for(i=1;i<=jumps[0];i++)
		{
			legMoves[2*i]=jump_at1;
			legMoves[2*i+1]=jumps[i];
		}
	}
	
	if(num_moves==1)
	{
		*from=legMoves[2];
		*to=legMoves[3];
		printf("depth = 0 time = 0 nodes = 0\n");
		return;
	}
	
	moves_so_far=getNumMoves();
	if(num_moves==0) /* if there are no moves */
	{
		*from=0; /*game over*/
		return;
	}
	else /* if there are moves */
	{
		for(i=0;i<num_moves;i++)
			spots[i]=i;
		scramble(spots,num_moves);
		level=1;
		do
		{
			alpha=LOSS;
			for(i=0;i<num_moves;i++) /* for each child board */
			{
				for(j=1;j<=NUM_SQUARES;j++) /* we are saving the potential board */
					wholeGame[moves_so_far+1][j]=allBoards[spots[i]][j];
				jump_at2=find_continuation(board,allBoards[spots[i]]);
				if(jump_at2==0) /* if there is going to be no continuation jump */
				{
					new_value=Min_Value(alpha, beta, color^1,allBoards[spots[i]],1,0);
					if(new_value==BAD_VALUE)
						break;
					new_value=MAX(alpha,new_value);
				}
				else /*??????? if this is a jump that can be continued */
				{
					new_value=Max_Value(alpha, beta, color,allBoards[spots[i]],0,jump_at2);
					if(new_value==BAD_VALUE)
						break;
					new_value=MIN(beta,new_value);
				}
				
				if(new_value>alpha&&new_value!=BAD_VALUE)
				{
					ivalue=i;
					alpha=new_value;
					best_value=new_value;
					*from=legMoves[2*spots[i]+2];
					*to=legMoves[2*spots[i]+3];
				}
			}/* end for each child board*/
			swap(&spots[0],&spots[ivalue]);
			level++;
		} while(new_value!=BAD_VALUE&&level<MAX_LEVEL);
		printf("depth = %d time = %d best_value = %d nodes = %d\n",level-2, (clock()-start_time)/CLOCKS_PER_SEC,best_value,glob_counter);
		level=saved_level;
	}/* end if there are moves */
}/* end bestMove */

/* This function returns a 1 if color could hop over jumpsquare. It returns 
0 otherwise. X and y are thecoordinates of the jumpsquare */
int can_hop_over_square(int board[NUM_SQUARES+1],int color,int x,int y)
{
	int upleft=-1,upright=-1,lowright=-1,lowleft=-1;
	
	y--;
	x--;
	if(x>0&&x<=BOARDSIZE&&y>0&&y<=BOARDSIZE)
		upleft=board[XY_TO_CHECKERS(x,y)];
	x+=2;
	if(x>0&&x<=BOARDSIZE&&y>0&&y<=BOARDSIZE)
		upright=board[XY_TO_CHECKERS(x,y)];
	y+=2;
	if(x>0&&x<=BOARDSIZE&&y>0&&y<=BOARDSIZE)
		lowright=board[XY_TO_CHECKERS(x,y)];
	x-=2;
	if(x>0&&x<=BOARDSIZE&&y>0&&y<=BOARDSIZE)
		lowleft=board[XY_TO_CHECKERS(x,y)];
	
	if((upleft==color+2)||(color==RED&&upleft==RED))
	{
		if(lowright==EMPTY)
			return(1);
	}
	
	if((upright==color+2)||(color==RED&&upright==RED))
	{
		if(lowleft==EMPTY)
			return(1);
	}
	
	if((lowright==color+2)||(color==WHITE&&lowright==WHITE))
	{
		if(upleft==EMPTY)
			return(1);
	}
	
	if((lowleft==color+2)||(color==WHITE&&lowleft==WHITE))
	{
		if(upright==EMPTY)
			return(1);
	}
	
	return(0);
}/* end can_hop_over_square() */

int chasing(int board[BOARDSIZE+1],int color, int depth)
{
	int i;
	int legMoves[MAX_MOVES];
	int num_friend_men=0,num_enemy_men=0;
	int num_friend_kings=0, num_enemy_kings=0,sum=0;
	int repeat_depth=0;
	int farness;
	for(i=1;i<=NUM_SQUARES;i++)
	{
		if(board[i]==color)
			num_friend_men++;
		else if(board[i]==color+2)
			num_friend_kings++;
		else if (board[i]==(color^1))
			num_enemy_men++;
		else if(board[i]==((color^1)+2))
			num_enemy_kings++;
	}
	sum=(num_friend_men+num_friend_kings-num_enemy_men-num_enemy_kings)*6000;
	if(sum>0) /*some inscentive to trade when you are winning */
	{
		sum=sum+500*(12-(num_enemy_men+num_enemy_kings));
		farness=farness_of_kings(board,turn);
		sum=sum-farness;
		repeat_depth=isRepeat(2);
		if(repeat_depth)
			sum=sum-400; 
	}
	else if(sum==0)
	{
		repeat_depth=isRepeat(2);
		if(repeat_depth)
			sum=sum-400; 
	}
	else if (sum<0) /*some inscentive not to trade when you are losing */
	{
		sum=sum-500*(12-(num_friend_men+num_friend_kings));
		farness=farness_of_kings(board,turn^1);
		sum=sum+farness;
		repeat_depth=isRepeat(1);
		if(repeat_depth)
			sum=sum+400; 
	}
	sum=sum+3500*(num_friend_kings-num_enemy_kings); /* some inscentive to get kings and jump kings */
	findLegalMoves(turn^1, board, legMoves);
	if (num_friend_men+num_friend_kings==0) /*if it is a losing position*/
		sum=LOSS+depth; /*worse at lower depth*/ 
	if((num_enemy_men+num_enemy_kings==0)||(legMoves[0]==0)) /*if it is a winning position*/
		sum=WIN-depth; /*better at lower depth*/
	return(sum);
}/* end chasing() */


/*This should help bring kings closer to the action */
int farness_of_kings(int board[NUM_SQUARES+1],int color)
{
	int i,j,x1,y1,x2,y2,distance=0,this_distance=0,min_distance=0;
	int opcolor=color^1;
	
	for(i=1;i<=NUM_SQUARES;i++)
	{
		if(board[i]==color+2) /* if it is your king */
		{
			min_distance=WIN; /* a big number */
			for(j=1;j<=NUM_SQUARES;j++)
			{
				if((board[j]==opcolor)||(board[j]==opcolor+2)) /* if it is an enemy piece */
				{
					checkers_to_xy(i,&x1,&y1);
					checkers_to_xy(j,&x2,&y2);
					/*I am squaring the distances to count far ones more */
					this_distance=(x1-x2)*(x1-x2)+(y1-y2)*(y1-y2);
					min_distance=MIN(this_distance,min_distance);
				}/*end if */
			}/*end for j*/
			if(min_distance!=WIN) /* if the opponent has at least one peice */
				distance=distance+min_distance;
			else
				return(0);
		}/*end if*/
	}/*end for i */
	return(distance);
}/*end farness_of_kings()*/

/*This should help bring kings closer to the action */
int farness_of_kings2(int board[NUM_SQUARES+1],int color, int trapped[BOARDSIZE*3/2+1])
{
	int i,j,k,x1,y1,x2,y2,distance=0,this_distance=0,min_distance=0;
	int opcolor=color^1;
	int stuck;
	
	for(i=1;i<=NUM_SQUARES;i++)
	{
		if(board[i]==color+2) /* if it is your king */
		{
			min_distance=WIN; /* a big number */
			for(j=1;j<=NUM_SQUARES;j++)
			{
				if((board[j]==opcolor)||(board[j]==opcolor+2)) /* if it is an enemy piece */
				{
					stuck=0;
					for(k=1;k<=trapped[0];k++)
					{
						if(j==trapped[k])
						{
							stuck=1;
							break;
						}
					}
					if(stuck==0)
					{
						checkers_to_xy(i,&x1,&y1);
						checkers_to_xy(j,&x2,&y2);
						/*I am squaring the distances to count far ones more */
						this_distance=MAX(abs(x1-x2),abs(y1-y2));
						this_distance=this_distance*this_distance;
						min_distance=MIN(this_distance,min_distance);
					}/* end if peice is not trapped */
				}/*end if */
			}/*end for j*/
			if(min_distance!=WIN) /* if the opponent has at least one peice */
				distance=distance+min_distance;
			else
				return(0);
		}/*end if*/
	}/*end for i */
	return(distance);
}/*end farness_of_kings2()*/

/*This should help bring kings closer to the action */
int farness_of_kings3(int board[NUM_SQUARES+1],int color)
{
	int i,j,x1,y1,x2,y2,distance=0,this_distance=0,min_distance=0;
	int opcolor=color^1;
	
	for(i=1;i<=NUM_SQUARES;i++)
	{
		if(board[i]==color+2) /* if it is your king */
		{
			min_distance=WIN; /* a big number */
			for(j=1;j<=NUM_SQUARES;j++)
			{
				if((board[j]==opcolor)||(board[j]==opcolor+2)) /* if it is an enemy piece */
				{
					checkers_to_xy(i,&x1,&y1);
					checkers_to_xy(j,&x2,&y2);
					/*I am squaring the distances to count far ones more */
					this_distance=MAX(abs(x1-x2),abs(y1-y2));
					this_distance=this_distance*this_distance;
					min_distance=MIN(this_distance,min_distance);
				}/*end if */
			}/*end for j*/
			if(min_distance!=WIN) /* if the opponent has at least one peice */
				distance=distance+min_distance;
			else
				return(0);
		}/*end if*/
	}/*end for i */
	return(distance);
}/*end farness_of_kings3()*/

int farness_of_pawns(int color, int board[NUM_SQUARES+1])
{
	int i,x,y,sum=0;
	for(i=1;i<=NUM_SQUARES;i++)
	{
		if(board[i]==color)
		{
			checkers_to_xy(i,&x,&y);
			if(color==RED)
				sum = sum+(BOARDSIZE-y);
			else if(color==WHITE)
				sum = sum+(y-1);
		}
	}
	return(sum);
}/* end farness of pawns() */

 /*This function takes into consideration that when you have
 less peices each one is more valuable to you. Also kings
are considered good*/
int global_forcing(int board[BOARDSIZE+1],int color, int depth)
{
	int i;
	int num_friend_men=0,num_enemy_men=0;
	int num_friend_kings=0, num_enemy_kings=0,sum=0;
	int safeness;
	int repeat_depth=0;
	for(i=1;i<=NUM_SQUARES;i++)
	{
		if(board[i]==color)
			num_friend_men++;
		else if(board[i]==color+2)
			num_friend_kings++;
		else if (board[i]==(color^1))
			num_enemy_men++;
		else if(board[i]==((color^1)+2))
			num_enemy_kings++;
	}
	sum=(num_friend_men+num_friend_kings-num_enemy_men-num_enemy_kings)*1200;
	safeness=num_safe_moves(board,turn^1); 
	if(sum>0) /*some inscentive to trade when you are winning*/
	{
		sum=sum+100*(12-(num_enemy_men+num_enemy_kings));
		sum=sum-safeness; /* minimize # of opponents moves */
		repeat_depth=isRepeat(2);
		if(repeat_depth)
			sum=sum-50; 
	}
	else if(sum==0)
	{
		repeat_depth=isRepeat(2);
		if(repeat_depth)
			sum=sum-50; 
	}
	else if (sum<0) /*some inscentive not to trade when you are losing */
		sum=sum-100*(12-(num_friend_men+num_friend_kings));
	sum=sum+700*(num_friend_kings-num_enemy_kings); /* some inscentive to get kings and jump kings */
	if (num_friend_men+num_friend_kings==0) /*if it is a losing position*/
		sum=LOSS+depth; /*worse at lower depth*/ 
	if((num_enemy_men+num_enemy_kings==0)||(safeness==-1)) /*if it is a winning position*/
		sum=WIN-depth; /*better at lower depth*/
	return(sum);
}



/* a very inefficient way to check for forced moves*/
int isForced(int board[BOARDSIZE+1])
{
	if(isLegalJumps(RED,board))
		return(1);
	if(isLegalJumps(WHITE,board))
		return(1);
	return(0);
}

/* This funtion returns a 0 if board is NOT a position of the past and 
a the depth of the repeat otherwise */
int isRepeat(int depth)
{
	int i,j;
	int num_empty1=0,num_empty2;
	int sameness;
	int num_moves=0;
	int num_red_kings=0;
	int num_white_kings=0;
	
	num_moves=getNumMoves();
	
	for(j=1;j<=NUM_SQUARES;j++)
	{
		if(wholeGame[num_moves+1][j]==EMPTY)
			num_empty1++;
		else if(wholeGame[num_moves+1][j]==RED_KING)
			num_red_kings++;
		else if(wholeGame[num_moves+1][j]==WHITE_KING)
			num_white_kings++;
	}	
	if(num_red_kings==0||num_white_kings==0) /* both sides need kings for a repeated posotion */
		return(0);
	
	for(i=num_moves-3;i>=num_moves+1-4*depth&&i>0;i-=4) 
	{
		sameness=1;
		num_empty2=0;
		for(j=1;j<=NUM_SQUARES;j++)
		{
			if(wholeGame[i][j]!=wholeGame[num_moves+1][j])
				sameness=0;
			if(wholeGame[i][j]==EMPTY)
				num_empty2++;
		}
		if(sameness==1)
			return(num_moves-i+1);
		if(num_empty1!=num_empty2) /* if this board has less peices then the current board */
			return(0);
	}
	return(0);
}/* end is_repeat() */

/*This function takes into consideration that when you have
less peices each one is more valuable to you. Also kings
are considered good*/
int kings_peices_trades(int board[BOARDSIZE+1],int color, int depth)
{
	int i;
	int num_friend_men=0,num_enemy_men=0;
	int num_friend_kings=0, num_enemy_kings=0,sum=0;
	int legMoves[MAX_MOVES];
	for(i=1;i<=NUM_SQUARES;i++)
	{
		if(board[i]==color)
			num_friend_men++;
		else if(board[i]==color+2)
			num_friend_kings++;
		else if (board[i]==(color^1))
			num_enemy_men++;
		else if(board[i]==((color^1)+2))
			num_enemy_kings++;
	}
	sum=(num_friend_men+num_friend_kings-num_enemy_men-num_enemy_kings)*12;
	if(sum>0) /*some inscentive to trade when you are winning */
		sum=sum+(12-(num_enemy_men+num_enemy_kings));
	else if (sum<0) /*some inscentive not to trade when you are losing */
		sum=sum-(12-(num_friend_men+num_friend_kings));
	sum=sum+7*(num_friend_kings-num_enemy_kings); /* some inscentive to get kings and jump kings */
	sum=sum+last_rank_difference(board,color);/* new part */
	findLegalMoves(turn^1, board, legMoves);
	if (num_friend_men+num_friend_kings==0) /*if it is a losing position*/
		sum=LOSS+depth; /*worse at lower depth*/ 
	if((num_enemy_men+num_enemy_kings==0)||(legMoves[0]==0)) /*if it is a winning position*/
		sum=WIN-depth; /*better at lower depth*/
	return(sum);
}

/*ACTUALLY THIS HEURISTIC ISN'T RELEVANT WHEN THE OTHER GUY JUST HAS 
KINGS */
int last_rank_difference(int board[NUM_SQUARES+1],int color)
{
	int i;
	int sum=0;
	for(i=1;i<=BOARDSIZE/2;i++)
	{
		if(board[i]==RED)
			sum++;
	}
	for(i=NUM_SQUARES-BOARDSIZE/2+1;i<=NUM_SQUARES;i++)
	{
		if(board[i]==WHITE)
			sum--;
	}
	if(color==WHITE)
		return(-1*sum);
	return(sum);
}


int Max_Value(int alpha,int beta, int color,int board[NUM_SQUARES+1],int depth,int jump_from)
{
	int num_moves,allBoards[MAX_MOVES][NUM_SQUARES+1];
	int i,jump_at=0;
	int result;
	
	glob_counter++;
	if(glob_counter%TIME_INTERVAL==0) /** check if time is up **/
	{
		if(level>1) /** don't interupt the first level **/
		{
			if(turn==RED)
			{
				if((clock()-start_time)/CLOCKS_PER_SEC >= redLevel)
					return(BAD_VALUE);
			}
			else 
			{
				if((clock()-start_time)/CLOCKS_PER_SEC >= whiteLevel)
					return(BAD_VALUE);
			}
		}
	}
	
	if(jump_from==0) /* if this is not a continuation jump */
		num_moves=findLegalBoards(color,board,allBoards);
	else /* if this is a continuation jump */
		num_moves=findLegalBoardsFromSquare(board,allBoards,jump_from);
	
	if((depth>=level&&isForced(board)==0)||num_moves==0) /*cutoff test*/
	{
		if (turn==RED)
		{
			switch(red_strategy)
			{
			case 1:
				return(peice_difference(board,turn));
			case 2:
				return(weighted_peice_difference(board,turn));
			case 3:
				return(kings_peices_trades(board,turn,depth));
			case 4:
				return(global_forcing(board,turn,depth));
			case 5:
				return(chasing(board,turn,depth));
			case 6:
				return(traps(board,color,depth));
			case 7:
				return(unified1(board,turn,depth));
			case 8:
				return(super_ext(board,color,depth));
			case 9:
				return(anti_jef(board,turn,depth));
			case 10:
				return(unified2(board,turn,depth));
			case 11:
				return(unified1b(board,turn,depth));
			}
		}
		else if(turn==WHITE)
		{
			switch(white_strategy)
			{
			case 1:
				return(peice_difference(board,turn));
			case 2:
				return(weighted_peice_difference(board,turn));
			case 3:
				return(kings_peices_trades(board,turn,depth));
			case 4:
				return(global_forcing(board,turn,depth));
			case 5:
				return(chasing(board,turn,depth));
			case 6:
				return(traps(board,color,depth));
			case 7:
				return(unified1(board,turn,depth));
			case 8:
				return(super_ext(board,color,depth));
			case 9:
				return(anti_jef(board,turn,depth));
			case 10:
				return(unified2(board,turn,depth));
			case 11:
				return(unified1b(board,turn,depth));
			}
		}
		else
		{
			printf("turn had an invalid value of %d\n",turn);
			exit(0);
		}
	}/*end cutoff test */
	
	for(i=0;i<num_moves;i++) /* for each child board */
	{
		jump_at=find_continuation(board,allBoards[i]);
		if(jump_at==0) /* if there is going to be no continuation jump */
		{
			result=Min_Value(alpha, beta, color^1,allBoards[i],depth+1,0);
			if(result==BAD_VALUE)
				return(BAD_VALUE);
			alpha=MAX(alpha,result);
		}
		else /*??????? if this is a jump that can be continued */
		{
			result=Max_Value(alpha, beta, color,allBoards[i],depth,jump_at);
			if(result==BAD_VALUE)
				return(BAD_VALUE);
			alpha=MIN(beta,result);
		}
		if(alpha>=beta)
			return(beta);
	}/* end for each child board*/
	return(alpha);
}

int Min_Value(int alpha,int beta, int color,int board[NUM_SQUARES+1],int depth,int jump_from)
{
	int num_moves,allBoards[MAX_MOVES][NUM_SQUARES+1];
	int i,jump_at=0;
	int result;
	
	glob_counter++;
	if(glob_counter%TIME_INTERVAL==0) /** check if time is up **/
	{
		if(level>1) /** don't do this on the first level **/ 
		{
			if(turn==RED)
			{
				if((clock()-start_time)/CLOCKS_PER_SEC >= redLevel)
					return(BAD_VALUE);
			}
			else 
			{
				if((clock()-start_time)/CLOCKS_PER_SEC >= whiteLevel)
					return(BAD_VALUE);
			}
		}
	}
	
	if(jump_from==0) /* if this is not a continuation jump */
		num_moves=findLegalBoards(color,board,allBoards);
	else /* if this is a continuation jump */
		num_moves=findLegalBoardsFromSquare(board,allBoards,jump_from);
	
	if((depth>=level&&isForced(board)==0)||num_moves==0) /*cutoff test*/
	{
		if (turn==RED)
		{
			switch(red_strategy)
			{
			case 1:
				return(peice_difference(board,turn));
			case 2:
				return(weighted_peice_difference(board,turn));
			case 3:
				return(kings_peices_trades(board,turn,depth));
			case 4:
				return(global_forcing(board,turn,depth));
			case 5:
				return(chasing(board,turn,depth));
			case 6:
				return(traps(board,color,depth));
			case 7:
				return(unified1(board,turn,depth));
			case 8:
				return(super_ext(board,color,depth));
			case 9:
				return(anti_jef(board,turn,depth));
			case 10:
				return(unified2(board,turn,depth));
			case 11:
				return(unified1b(board,turn,depth));
			}
		}
		else if(turn==WHITE)
		{
			switch(white_strategy)
			{
			case 1:
				return(peice_difference(board,turn));
			case 2:
				return(weighted_peice_difference(board,turn));
			case 3:
				return(kings_peices_trades(board,turn,depth));
			case 4:
				return(global_forcing(board,turn,depth));
			case 5:
				return(chasing(board,turn,depth));
			case 6:
				return(traps(board,color,depth));
			case 7:
				return(unified1(board,turn,depth));
			case 8:
				return(super_ext(board,color,depth));
			case 9:
				return(anti_jef(board,turn,depth));
			case 10:
				return(unified2(board,turn,depth));
			case 11:
				return(unified1b(board,turn,depth));
			}
		}
		else
		{
			printf("turn had an invalid value of %d\n",turn);
			exit(0);
		}
	}/*end cutoff test */
	
	for(i=0;i<num_moves;i++) /* for each child board */
	{
		jump_at=find_continuation(board,allBoards[i]);
		if(jump_at==0) /* if there is going to be no continuation jump */
		{
			result=Max_Value(alpha, beta, color^1,allBoards[i],depth+1,0);
			if(result==BAD_VALUE)
				return(BAD_VALUE);
			beta=MIN(beta,result);
		}
		else /*??????? if this is a jump that can be continued */
		{
			result=Min_Value(alpha, beta, color,allBoards[i],depth,jump_at);
			if(result==BAD_VALUE)
				return(BAD_VALUE);
			beta=MAX(alpha,result);
		}
		if(beta<=alpha)
			return(alpha);
	}/* end for each child board*/
	return(beta);
}

int num_in_last_rank(int board[NUM_SQUARES+1],int color)
{
	int i;
	int sum=0;
	
	if(color==RED)
	{
		for(i=1;i<=BOARDSIZE/2;i++)
		{
			if(board[i]==RED)
				sum++;
		}
	}
	else if(color==WHITE)
	{
		for(i=NUM_SQUARES-BOARDSIZE/2+1;i<=NUM_SQUARES;i++)
		{
			if(board[i]==WHITE)
				sum++;
		}
	}
	return(sum);
} /* end num_in_last_rank() */

int num_peices_trapped(int board[NUM_SQUARES+1], int color, int trapped[BOARDSIZE*3/2+1])
{
	int i,x,y;
	int sum=0;
	int safe_move;
	int nextSquare;
	
	trapped[0]=0;

	for(i=1;i<=NUM_SQUARES;i++)
	{
		if(board[i]==color||board[i]==color+2) /* if it is your peices */
		{
			safe_move=0;
			checkers_to_xy(i,&x,&y);
			if(board[i]!=RED)
			{
				/****Check upper left*****/
				x--;
				y--; /***remember that y decreases as you go up **/
				if(x>0&&x<=BOARDSIZE&&y>0&&y<=BOARDSIZE)
				{	
					nextSquare=XY_TO_CHECKERS(x,y);
					if(board[nextSquare]==EMPTY)
					{
						safe_move++;
						board[nextSquare]=board[i];
						board[i]=EMPTY;
						if(can_hop_over_square(board,color^1,x,y))
							safe_move--;
						board[i]=board[nextSquare];
						board[nextSquare]=EMPTY;
					}
				}/*end if we did not go outside board */
				/****Check upper right*****/
				x+=2;
				if(x>0&&x<=BOARDSIZE&&y>0&&y<=BOARDSIZE)
				{	
					nextSquare=XY_TO_CHECKERS(x,y);
					if(board[nextSquare]==EMPTY)
					{
						board[nextSquare]=board[i];
						board[i]=EMPTY;
						safe_move++;
						if(can_hop_over_square(board,color^1,x,y))
							safe_move--;
						board[i]=board[nextSquare];
						board[nextSquare]=EMPTY;
					}
				}/*end if we did not go outside board */
				x--; /**go back to square with your peice **/
				y++;
			}/*end if you are not red */
			if(board[i]!=WHITE) /*if you are not white */
			{
				/****Check lower right*****/
				x++;
				y++;
				if(x>0&&x<=BOARDSIZE&&y>0&&y<=BOARDSIZE)
				{	
					nextSquare=XY_TO_CHECKERS(x,y);
					if(board[nextSquare]==EMPTY)
					{
						board[nextSquare]=board[i];
						board[i]=EMPTY;
						safe_move++;
						if(can_hop_over_square(board,color^1,x,y))
							safe_move--;
						board[i]=board[nextSquare];
						board[nextSquare]=EMPTY;
					}
				}/*end if we did not go outside board */
				/****Check lower left*****/
				x-=2;
				if(x>0&&x<=BOARDSIZE&&y>0&&y<=BOARDSIZE)
				{	
					nextSquare=XY_TO_CHECKERS(x,y);
					if(board[nextSquare]==EMPTY)
					{
						safe_move++;
						board[nextSquare]=board[i];
						board[i]=EMPTY;
						if(can_hop_over_square(board,color^1,x,y))
							safe_move--;
						board[i]=board[nextSquare];
						board[nextSquare]=EMPTY;
					}
				}/*end if we did not go outside board */
			}/*end if you are not white */
			
			if(safe_move==0)
			{
				sum++;
				trapped[0]++;
				trapped[trapped[0]]=i;
			}
		} /* end if it is your peice */
	}/* end for each square */
	return(sum);
}/* end num_peices_trapped() */


/* This function returns -1 if the game is lost. Otherwise it returns
the number of moves you can make where the opponent doesn't jump you. */
int num_safe_moves(int board[NUM_SQUARES+1], int color)
{
	int sum, num_moves, i;
	int allBoards[MAX_MOVES][NUM_SQUARES+1];
	int legMoves[MAX_MOVES];
	num_moves=findLegalBoards(color,board,allBoards);
	if(num_moves==0) /*if game is lost */
		return(-1); 
	sum=num_moves;
	for(i=0;i<num_moves;i++)
	{
		findLegalMoves(color^1,allBoards[i],legMoves);
		if(legMoves[1]>0)
			sum--;
	}
	return(sum);
}

/*this function returns the difference between the #
of peices between you and your opponent counting kings*/
int peice_difference(int board[BOARDSIZE+1],int color)
{
	int sum=0,i;
	for(i=1;i<=NUM_SQUARES;i++)
	{
		if(board[i]==color||board[i]==color+2)
			sum++;
		else if (board[i]!=EMPTY)
			sum--;
	}
	return(sum);
}

void print_heuristics(int board[NUM_SQUARES+1], int color)
{
	int trapped[BOARDSIZE*3/2+1],i;

	hr();
	if(color==RED)
		printf("			RED\n");
	else
		printf("			WHITE\n");
	printf("The farness of kings = %d.\n",farness_of_kings(board,color));
	printf("The farness of pawns = %d.\n",farness_of_pawns(color,board));
	if(isForced(board))
		printf("This board is forced.\n");
	else
		printf("This board is NOT forced.\n");
	if(isRepeat(1))
		printf("This is a repeated position.\n");
	else
		printf("This is NOT a repeated position.\n");
	printf("Last rank difference = %d.\n",last_rank_difference(board,color));
	printf("# peices in last ranke = %d.\n",num_in_last_rank(board,color));
	printf("# of safe moves = %d.\n",num_safe_moves(board,color));
	printf("peice difference = %d.\n",peice_difference(board,color));
	printf("num_peices opponents peices trapped = %d.\n",num_peices_trapped(board,color^1,trapped));
	printf("The farness of kings to untrapped peices = %d.\n",farness_of_kings2(board,color,trapped));
	printf("The trapped peices are:\n");
	for(i=1;i<=trapped[0];i++)
		printf("%d, ",trapped[i]);
	printf("\n");
	hr();
	return;
}/* end print_heuristics */

/* find a random jump from 'from' to '*to' */
void randomJump(int board[BOARDSIZE],int* to,int from)
{
	int legMoves[5]={0};/* can contain only 4 jumps */
	int i;
	findLegalJumpsFromSquare(board,legMoves,from);
	*to=0;
	if(legMoves[0]!=0)
	{
		i=rand()*10001%legMoves[0];
		*to = legMoves[i+1];
	}
	else
		printf("There were no jumps for randomJump!\n");
	return;
}

void randomMove(int board[BOARDSIZE],int color, int* from, int* to)
{
	int legMoves[MAX_MOVES]={0};
	int i;
	
	findLegalMoves(color,board,legMoves);	
	if(legMoves[0]==0) /*game is lost */
	{
		*from=0;
		*to=0;
	}
	else
	{
		
		i=rand()*10001%legMoves[0];
		*from = legMoves[2*i+2];
		*to = legMoves[2*i+3];
	}
	return;
}

int super_ext(int board[BOARDSIZE+1],int color, int depth)
{
	int saved_level=level;
	int best_value,num_moves,num_empty1=0,num_empty2=0;
	int i,allBoards[MAX_MOVES][NUM_SQUARES+1];
	int alpha,beta,jump_at2,new_value;
	int before;

	if(level<2||turn!=color)
		return(unified1(board,turn,depth));
	num_moves=getNumMoves();
	for(i=1;i<=NUM_SQUARES;i++)
	{
		if(board[i]==EMPTY)
			num_empty1++;
		if(wholeGame[num_moves][i]==EMPTY)
			num_empty2++;
	}
	if(num_empty1==num_empty2)
		return(unified1(board,turn,depth));
	level=2; /***THIS IS THE LEVEL OF THE ADDITIONAL EXTENTION */
	if(turn==RED)
		red_strategy=7;
	else
		white_strategy=7; /*unified1*/
	
	/********FIND VALUE OF THIS BOARD AT DEPTH 2(with quiescience) ***/
	num_moves=findLegalBoards(color,board,allBoards);
	
	if(num_moves==0) /* if there are no moves */
	{
		if(turn==RED)
			red_strategy=8;
		else if(turn==WHITE)
			white_strategy=8; /*super ext */
		level=saved_level;
		if(color==turn)
			return(LOSS+depth);
		return(WIN-depth);
	}
	else /* if there are moves to choose from */
	{
		alpha=LOSS;
		beta=WIN;
		before=(unified1(board,turn,depth));
/*****THIS MIGHT ALL BE WRONG IF COLOR^1!=turn! ********/		
		for(i=0;i<num_moves;i++) /* for each child board */
		{
			jump_at2=find_continuation(board,allBoards[i]);
			if(jump_at2==0) /* if there is going to be no continuation jump */
			{
				new_value=Min_Value(alpha, beta, color^1,allBoards[i],1,0);
				if(new_value==BAD_VALUE)
				{
					printf("time ran out doing super_ext\n");
					if(turn==RED)
						red_strategy=8;
					else if(turn==WHITE)
						white_strategy=8; /*super ext */
					level=saved_level;
					return(BAD_VALUE);
				}
				new_value=MAX(alpha,new_value);
			}
			else /*??????? if this is a jump that can be continued */
			{
				new_value=Max_Value(alpha, beta, color,allBoards[i],0,jump_at2);
				if(new_value==BAD_VALUE)
				{
					printf("time ran out doing super_ext\n");
					if(turn==RED)
						red_strategy=8;
					else if(turn==WHITE)
						white_strategy=8; /*super ext */
					level=saved_level;
					return(BAD_VALUE);
				}
				new_value=MIN(beta,new_value);
			}
			if(new_value>alpha&&new_value!=BAD_VALUE)
			{
				alpha=new_value;
				best_value=new_value;
			}
		}/* end for each child board*/
	}/* end for each board */
	/******************************************/
	if(turn==RED)
		red_strategy=8;
	else if(turn==WHITE)
		white_strategy=8; /*super ext */
	level=saved_level;
	printf("before_ext=%d after_ext=%d\n",before,best_value);
	return(best_value);
}/*end super_ext()*/

/* a heuristic that takes into account the number of trapped peices */
int traps(int board[BOARDSIZE+1], int color, int depth)
{
	int i;
	int num_friend_men=0,num_enemy_men=0;
	int num_friend_kings=0, num_enemy_kings=0,sum=0;
	int legMoves[MAX_MOVES];
	int trapped[BOARDSIZE*3/2+1];
	for(i=1;i<=NUM_SQUARES;i++)
	{
		if(board[i]==turn)
			num_friend_men++;
		else if(board[i]==turn+2)
			num_friend_kings++;
		else if (board[i]==(turn^1))
			num_enemy_men++;
		else if(board[i]==((turn^1)+2))
			num_enemy_kings++;
	}
	sum=(num_friend_men+num_friend_kings-num_enemy_men-num_enemy_kings)*12;
	if(sum>0) /*some inscentive to trade when you are winning */
	{
		sum=sum+9*(12-(num_enemy_men+num_enemy_kings));
		sum=sum+num_peices_trapped(board,turn^1,trapped);
	}
	else if (sum<0) /*some inscentive not to trade when you are losing */
	{
		sum=sum-9*(12-(num_friend_men+num_friend_kings));
		sum=sum-num_peices_trapped(board,turn,trapped);
	}
	sum=sum+7*(num_friend_kings-num_enemy_kings); /* some inscentive to get kings and jump kings */
	findLegalMoves(color^1, board, legMoves);
	if(legMoves[0]==0) /* if there are no legal for the next guy */
	{
		if(color==turn)	
			sum=WIN-depth;
		else
			sum=LOSS+depth;
	}
	if (num_friend_men+num_friend_kings==0) /*if it is a losing position*/
		sum=LOSS+depth; /*worse at lower depth*/ 
	if(num_enemy_men+num_enemy_kings==0) /*if it is a winning position*/
		sum=WIN-depth; /*better at lower depth*/
	return(sum);
}/* end traps() */

int unified1(int board[BOARDSIZE+1],int color, int depth)
{
	int i;
	int legMoves[MAX_MOVES];
	int num_friend_men=0,num_enemy_men=0;
	int num_friend_kings=0, num_enemy_kings=0,sum=0;
	int repeat_depth=0;

	/*printf("depth = %d\n",depth);*/

	for(i=1;i<=NUM_SQUARES;i++)
	{
		if(board[i]==color)
			num_friend_men++;
		else if(board[i]==color+2)
			num_friend_kings++;
		else if (board[i]==(color^1))
			num_enemy_men++;
		else if(board[i]==((color^1)+2))
			num_enemy_kings++;
	}
	sum=(num_friend_men+num_friend_kings-num_enemy_men-num_enemy_kings)*1200000;
	if(sum>0) /*some inscentive to trade when you are winning */
	{
		sum=sum+100000*(12-(num_enemy_men+num_enemy_kings));
		if(num_friend_kings > 0)
			sum=sum-farness_of_kings(board,turn);
		repeat_depth=isRepeat(2);
		if(repeat_depth)
			sum=sum-50000;
		/*sum=sum+15000*num_peices_trapped(board,turn^1);*/
		sum=sum-num_safe_moves(board,turn^1);
		/*sum=sum+60*num_safe_moves(board,turn);*/
	}
	else if(sum==0)
	{
		repeat_depth=isRepeat(2);
		if(repeat_depth)
			sum=sum-50000; 
		if(num_friend_kings > 0)
			sum=sum-farness_of_kings(board,turn);
			/*	sum=sum+15000*num_peices_trapped(board,turn^1);
		sum=sum-15000*num_peices_trapped(board,turn); */
		sum=sum-num_safe_moves(board,turn^1);
		sum=sum+num_safe_moves(board,turn); 
	}
	else if (sum<0) /*some inscentive not to trade when you are losing */
	{
		sum=sum-100000*(12-(num_friend_men+num_friend_kings));
		if(num_enemy_kings>0)
			sum=sum+farness_of_kings(board,turn^1);
		repeat_depth=isRepeat(1);
		if(repeat_depth)
			sum=sum+50000; 
		/*sum=sum-15000*num_peices_trapped(board,turn);*/
		/*	sum=sum-60*num_safe_moves(board,turn^1);*/
		sum=sum+num_safe_moves(board,turn);
	}
	
	/*sum=sum-farness_of_pawns_weighted(turn,board);
	sum=sum+farness_of_pawns_weighted(turn^1,board);*/
	if(num_enemy_men>0)
		sum=sum+3*num_in_last_rank(board,turn);
	else
		sum=sum-3*farness_of_pawns(turn,board);
	if(num_friend_men>0)
		sum=sum-3*num_in_last_rank(board,turn^1);
	else
		sum=sum+3*farness_of_pawns(turn^1,board); /* the farther the better */
	sum=sum+700000*(num_friend_kings-num_enemy_kings); /* some inscentive to get kings and jump kings */
	findLegalMoves(color^1, board, legMoves);
	if(legMoves[0]==0)
	{
		if(color==turn)
			sum=WIN-depth;
		else
			sum=LOSS+depth;
	}
	if (num_friend_men+num_friend_kings==0) /*if it is a losing position*/
		sum=LOSS+depth; /*worse at lower depth*/ 
	if(num_enemy_men+num_enemy_kings==0) /*if it is a winning position*/
		sum=WIN-depth; /*better at lower depth*/
	return(sum);
}/* end unified1()*/

/* This is like unified1 except it calculates the farness of
kings correctly */
int unified1b(int board[BOARDSIZE+1],int color, int depth)
{
	int i;
	int legMoves[MAX_MOVES];
	int num_friend_men=0,num_enemy_men=0;
	int num_friend_kings=0, num_enemy_kings=0,sum=0;
	int repeat_depth=0;

	/*printf("depth = %d\n",depth);*/

	for(i=1;i<=NUM_SQUARES;i++)
	{
		if(board[i]==color)
			num_friend_men++;
		else if(board[i]==color+2)
			num_friend_kings++;
		else if (board[i]==(color^1))
			num_enemy_men++;
		else if(board[i]==((color^1)+2))
			num_enemy_kings++;
	}
	sum=(num_friend_men+num_friend_kings-num_enemy_men-num_enemy_kings)*1200000;
	if(sum>0) /*some inscentive to trade when you are winning */
	{
		sum=sum+100000*(12-(num_enemy_men+num_enemy_kings));
		if(num_friend_kings > 0)
			sum=sum-farness_of_kings3(board,turn);
		repeat_depth=isRepeat(2);
		if(repeat_depth)
			sum=sum-50000;
		/*sum=sum+15000*num_peices_trapped(board,turn^1);*/
		sum=sum-num_safe_moves(board,turn^1);
		/*sum=sum+60*num_safe_moves(board,turn);*/
	}
	else if(sum==0)
	{
		repeat_depth=isRepeat(2);
		if(repeat_depth)
			sum=sum-50000; 
		if(num_friend_kings > 0)
			sum=sum-farness_of_kings3(board,turn);
			/*	sum=sum+15000*num_peices_trapped(board,turn^1);
		sum=sum-15000*num_peices_trapped(board,turn); */
		sum=sum-num_safe_moves(board,turn^1);
		sum=sum+num_safe_moves(board,turn); 
	}
	else if (sum<0) /*some inscentive not to trade when you are losing */
	{
		sum=sum-100000*(12-(num_friend_men+num_friend_kings));
		if(num_enemy_kings>0)
			sum=sum+farness_of_kings3(board,turn^1);
		repeat_depth=isRepeat(1);
		if(repeat_depth)
			sum=sum+50000; 
		/*sum=sum-15000*num_peices_trapped(board,turn);*/
		/*	sum=sum-60*num_safe_moves(board,turn^1);*/
		sum=sum+num_safe_moves(board,turn);
	}
	
	/*sum=sum-farness_of_pawns_weighted(turn,board);
	sum=sum+farness_of_pawns_weighted(turn^1,board);*/
	if(num_enemy_men>0)
		sum=sum+3*num_in_last_rank(board,turn);
	else
		sum=sum-3*farness_of_pawns(turn,board);
	if(num_friend_men>0)
		sum=sum-3*num_in_last_rank(board,turn^1);
	else
		sum=sum+3*farness_of_pawns(turn^1,board); /* the farther the better */
	sum=sum+700000*(num_friend_kings-num_enemy_kings); /* some inscentive to get kings and jump kings */
	findLegalMoves(color^1, board, legMoves);
	if(legMoves[0]==0)
	{
		if(color==turn)
			sum=WIN-depth;
		else
			sum=LOSS+depth;
	}
	if (num_friend_men+num_friend_kings==0) /*if it is a losing position*/
		sum=LOSS+depth; /*worse at lower depth*/ 
	if(num_enemy_men+num_enemy_kings==0) /*if it is a winning position*/
		sum=WIN-depth; /*better at lower depth*/
	return(sum);
} /* end unified_ib() */

int unified2(int board[BOARDSIZE+1],int color, int depth)
{
	int i;
	int legMoves[MAX_MOVES];
	int num_friend_men=0,num_enemy_men=0;
	int num_friend_kings=0, num_enemy_kings=0,sum=0;
	int repeat_depth=0;
	int trapped[BOARDSIZE*3/2+1];

	for(i=1;i<=NUM_SQUARES;i++)
	{
		if(board[i]==color)
			num_friend_men++;
		else if(board[i]==color+2)
			num_friend_kings++;
		else if (board[i]==(color^1))
			num_enemy_men++;
		else if(board[i]==((color^1)+2))
			num_enemy_kings++;
	}
	sum=(num_friend_men+num_friend_kings-num_enemy_men-num_enemy_kings)*1200000;
	if(sum>0) /*some inscentive to trade when you are winning */
	{
		sum=sum+100000*(12-(num_enemy_men+num_enemy_kings));
		repeat_depth=isRepeat(2);
		if(repeat_depth)
			sum=sum-50000;
		/*sum=sum+15000*num_peices_trapped(board,turn^1);*/
		sum=sum-num_safe_moves(board,turn^1);
		num_peices_trapped(board,turn^1,trapped);
		sum = sum + 24*trapped[0];
		if(num_friend_kings>0)
			sum = sum - farness_of_kings2(board,turn,trapped);
	}
	else if(sum==0)
	{
		repeat_depth=isRepeat(2);
		if(repeat_depth)
			sum=sum-50000; 
		num_peices_trapped(board,turn^1,trapped);
		sum = sum + 24*trapped[0];
		if(num_friend_kings > 0)
			sum = sum - farness_of_kings2(board,turn,trapped);
		num_peices_trapped(board,turn,trapped);
		sum = sum - 24*trapped[0];
		if(num_enemy_kings>0)
			sum = sum + farness_of_kings2(board,turn,trapped);
		sum=sum-num_safe_moves(board,turn^1);
		sum=sum+num_safe_moves(board,turn); 
	}
	else if (sum<0) /*some inscentive not to trade when you are losing */
	{
		sum=sum-100000*(12-(num_friend_men+num_friend_kings));
		num_peices_trapped(board,turn,trapped);
		sum = sum - 24*trapped[0];
		if(num_enemy_kings>0)
			sum = sum + farness_of_kings2(board,turn,trapped);
		repeat_depth=isRepeat(1);
		if(repeat_depth)
			sum=sum+50000; 
		/*sum=sum-15000*num_peices_trapped(board,turn);*/
		/*	sum=sum-60*num_safe_moves(board,turn^1);*/
		sum=sum+num_safe_moves(board,turn);
	}
	
	if(num_enemy_men>0)
		sum=sum+3*num_in_last_rank(board,turn);
	else
		sum=sum-3*farness_of_pawns(turn,board);
	if(num_friend_men>0)
		sum=sum-3*num_in_last_rank(board,turn^1);
	else
		sum=sum+3*farness_of_pawns(turn^1,board); /* the farther the better */
	sum=sum+700000*(num_friend_kings-num_enemy_kings); /* some inscentive to get kings and jump kings */
	findLegalMoves(color^1, board, legMoves);
	if(legMoves[0]==0)
	{
		if(color==turn)
			sum=WIN-depth;
		else
			sum=LOSS+depth;
	}
	if (num_friend_men+num_friend_kings==0) /*if it is a losing position*/
		sum=LOSS+depth; /*worse at lower depth*/ 
	if(num_enemy_men+num_enemy_kings==0) /*if it is a winning position*/
		sum=WIN-depth; /*better at lower depth*/
	return(sum);
}/* end unified 2()*/

/*This function takes into consideration that when you have
less peices each one is more valuable to you*/
int weighted_peice_difference(int board[BOARDSIZE+1],int color)
{
	int i;
	int num_friend=0,num_enemy=0,sum=0;
	for(i=1;i<=NUM_SQUARES;i++)
	{
		if(board[i]==color||board[i]==color+2)
			num_friend++;
		else if (board[i]!=EMPTY)
			num_enemy++;
	}
	sum=(num_friend-num_enemy)*12;
	if(sum>0)
		sum=sum+(12-num_enemy);
	else if (sum<0)
		sum=sum-(12-num_friend);
	if (num_friend==0)
		sum=LOSS;
	if(num_enemy==0)
		sum=WIN;
	return(sum);
}/* end weighted peice difference() */


